#include <TextView.h>
#include <Application.h>
#include <Window.h>
#include <iostream>
using namespace std;

class MouseView : public BTextView
{
  public:
    MouseView(BRect frame);
	virtual void KeyDown(const char *bytes, int32 numBytes);
    virtual void MouseMoved(BPoint point, uint32 transit, const BMessage *message);
    virtual void MouseDown(BPoint point);
    virtual void MouseUp(BPoint point);
};

MouseView::MouseView(BRect frame)
    :  BTextView(frame, "MouseView", frame, B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
  this->SetViewColor(255, 255, 200);
  this->SetLowColor(255, 255, 200);  
}

void MouseView::KeyDown(const char *bytes, int32 numBytes)
{
  cout << "Started KeyDown" << endl;
  snooze(1000000);
  for(int i = 0; i < numBytes; i++)
    cout << bytes[i];
  cout << endl;
  BTextView::KeyDown(bytes, numBytes);
  snooze(1000000);
  cout << "Finished KeyDown" << endl << endl;
}

void MouseView::MouseMoved(BPoint point, uint32 transit, const BMessage *message)
{
  cout << "Started MouseMoved" << endl;
  snooze(1000000);
  point.PrintToStream();
  BTextView::MouseMoved(point, transit, message);
  snooze(1000000);
  cout << "Finished MouseMoved" << endl << endl;
}

void MouseView::MouseDown(BPoint point)
{
  cout << "Started MouseDown" << endl;
  snooze(1000000);
  point.PrintToStream();
  BTextView::MouseDown(point);
  snooze(1000000);
  cout << "Finished MouseDown" << endl << endl;
}

void MouseView::MouseUp(BPoint point)
{
  cout << "Started MouseUp" << endl;
  snooze(1000000);
  point.PrintToStream();
  BTextView::MouseDown(point);
  snooze(1000000);
  cout << "Finished MouseUp" << endl << endl;
}

int main(int argc, char** argv)
{
  BApplication app("application/x-vnd.Simon-TestMouse");
  
  BWindow* wnd = new BWindow(BRect(100, 100, 400, 400), "Window", B_TITLED_WINDOW, B_QUIT_ON_WINDOW_CLOSE);
  MouseView* mv = new MouseView(BRect(10, 10, 290, 290));
  wnd->AddChild(mv); 
  wnd->Show();
  if(wnd->LockLooper())
  {
    mv->MakeFocus();
    mv->SetEventMask(0, B_NO_POINTER_HISTORY);
    wnd->UnlockLooper();
  }
  
  app.Run();
  
  return 0;
}

